/*
 * \file str.c
 * \brief string operation
 * \author Simpp
 */
/*
 *    This file is part of Maketh.
 *
 *  Maketh is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Maketh is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Maketh.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "maketh.h"

int
strtoint (const char *str)
{
  int val;
  const char *pstr = str;

  val = 0;
  while (*pstr)
    {
      if (*pstr >= '0' && *pstr <= '9')
        {
          val *= 10;
          val += *pstr - '0';
        }
      else
        error (1, "[strtoint()] bad argument <", str, ">.\n", NULL);
      pstr++;
    }

  return val;
}
