#include <stdio.h>
#include <stdlib.h>

extern char *progname;

void
usage (void)
{
  printf ("USAGE : %s [TARGET] [ARGV1] [ARGV2] ...\nPROGRAM INFORMATION :\n"
	  "\r\t--help or -h \r\t\t\t\t\t: -h print US help or  -hh print FR help.\n"
	  "\r\t--version or -v \r\t\t\t\t\t: Print program version.\n"
	  "\nPROGRAM CONFIG :\n"
	  "\r\t--count or -c [COUNT] \r\t\t\t\t\t: Numbers of packet to send.\n"
	  "\r\t--data or -l [LEN_DATA] \r\t\t\t\t\t: Size of data.\n"
	  "\r\t--file or -f [FILE_NAME] \r\t\t\t\t\t: Read data of a file.\n"
	  "\r\t--proto or -p [PROTOCOL] \r\t\t\t\t\t: Choose protocol :\n"
	  "\r\t\t\t\t\t   arp, ip, tcp, udp, icmp (igmp not implented)\n"
	  "\r\t--index or -I [INDEX] \r\t\t\t\t\t: Number of network device.\n"
	  "\r\t--device or -i [DEVICE] \r\t\t\t\t\t: Name of network device\n."
	  "\r\t--mtu or -m [MTU] \r\t\t\t\t\t: MTU\n"
	  "\r\t--timeout or -E [TIMEOUT] \r\t\t\t\t\t: Timeout packet.\n"
	  "\r\t--ign-echo \r\t\t\t\t\t: Ignore ICMP echo during starting program\n"
	  "\nRECV PACKET CONFIG :\n"
	  "\r\t--no-recv or -W \r\t\t\t\t\t: Don't read the answers.\n"
	  "\r\t--verbose-recv or -V \r\t\t\t\t\t: Print packet with more possible details.\n"
	  "\r\t--hexa-recv or -H \r\t\t\t\t\t: Print packet in hexadecimal.\n"
	  "\nCOMMON ALL PROTOCOL ETHERNET HEADER :\n"
	  "\r\t--eth-src or -y [MAC] \r\t\t\t\t\t: Ethernet MAC src.\n"
	  "\r\t--eth-dst or -Y [MAC] \r\t\t\t\t\t: Ethernet MAC dst.\n"
	  "\nARP HEADER:\n"
	  "\r\t--opcode or -o [OPCODE] \r\t\t\t\t\t: Opcode.\n"
	  "\r\t--ar-mac-src or -n [MAC] \r\t\t\t\t\t: ARP MAC src.\n"
	  "\r\t--ar-mac-dst or -N [MAC] \r\t\t\t\t\t: ARP MAC dst.\n"
	  "\r\t--ar-ip-src or -b [IP] \r\t\t\t\t\t: ARP IP src.\n"
	  "\r\t--ar-ip-dst or -B [IP] \r\t\t\t\t\t: ARP IP dst.\n"
	  "\nIP HEADER:\n"
	  "\r\t--source or -s [IP] \r\t\t\t\t\t: IP src.\n"
	  "\r\t--rand-src or -k \r\t\t\t\t\t: Random IP src for new packet.\n"
	  "\r\t--rand-ttl \r\t\t\t\t\t: Random TTL.\n"
	  "\r\t--rand-ip-id \r\t\t\t\t\t: Random ID.\n"
	  "\r\t--ip-id or -D [ID] \r\t\t\t\t\t: Fixed ID.\n"
	  "\r\t--ttl or -t [TTL] \r\t\t\t\t\t: Fixed TTL (default 169).\n"
	  "\r\t--rr \r\t\t\t\t\t: Option IP Record Route.\n"
	  "\r\t--lsr [IP1,IP2,IP3,...] \r\t\t\t\t\t: Option IP Loose Source Routing.\n"
	  "\r\t--ssr [IP1,IP2,IP3,...] \r\t\t\t\t\t: Option IP Strict Source Routing.\n"
	  "\nCOMMON ICMP AND IGMP HEADER :\n"
	  "\r\t--type or -T [TYPE] \r\t\t\t\t\t: Type (default 8 ECHO ICMP).\n"
	  "\r\t--code or -C [CODE] \r\t\t\t\t\t: Code (default 0).\n"
	  "\nIGMP HEADER :\n"
	  "\r\t--group or -G [GROUP] \r\t\t\t\t\t: Not implented.\n"
	  "\nICMP HEADER :\n"
	  "\r\t--icmp-seq or -j [SEQ] \r\t\t\t\t\t: Sequence fixed.\n"
	  "\r\t--icmp-id or -d [ID] \r\t\t\t\t\t: ID fixed.\n"
	  "\r\t--router or -r [IP] \r\t\t\t\t\t: Addr IP of the router (for ICMP type 5).\n"
	  "\nFOR ICMP TYPE : 3-4-5-11-12\n"
	  "\r\t--add-type or -0 [PROTOCOL] \r\t\t\t\t\t: protocol UDP or TCP (default TCP).\n"
	  "\r\t--add-ip-src or -1 [IP] \r\t\t\t\t\t: IP src.\n"
	  "\r\t--add-ip-dst or -2 [IP] \r\t\t\t\t\t: IP dst.\n"
	  "\r\t--add-p-src or -3 [PORT] \r\t\t\t\t\t: Port src.\n"
	  "\r\t--add-p-dst or -4 [PORT] \r\t\t\t\t\t: Port dst.\n"
	  "\r\t--add-ip-proto or -5 [PROTOCOL] \r\t\t\t\t\t: Protocole UDP or TCP.\n"
	  "\r\t--add-ip-ttl or -6 [TTL] \r\t\t\t\t\t: TTL.\n"
	  "\r\t--add-ip-id or -7 [ID] \r\t\t\t\t\t: ID.\n"
	  "\r\t--add-ip-fragof or -8 [OFFSET] \r\t\t\t\t\t: Fragment offset.\n"
	  "\r\t--add-ip-totlen or -Q [LEN] \r\t\t\t\t\t: Packet total size.\n"
	  "\r\t--add-tcp-seq or -9 [SEQ] \r\t\t\t\t\t: TCP sequence.\n"
	  "\r\t--add-udp-len or -z [LEN] \r\t\t\t\t\t: UDP header size.\n"
	  "\r\t--add-udp-check or -J [CHECKSUM] \r\t\t\t\t\t: UDP checksum.\n"
	  "\nICMP TYPE 13 & 14\n"
	  "\r\t--time-orig [TIMESTAMP] \r\t\t\t\t\t: Timestamp Origine.\n"
	  "\r\t--time-send [TIMESTAMP] \r\t\t\t\t\t: Timestamp to send (type 14).\n"
	  "\r\t--time-recv [TIMESTAMP] \r\t\t\t\t\t: Timestamp to recv (type 14).\n"
	  "\nCOMMON TCP AND UDP HEADER :\n"
	  "\r\t--psrc or -x [PORT] \r\t\t\t\t\t: Port src.\n"
	  "\r\t--pdst or -X [PORT] \r\t\t\t\t\t: Port dst.\n"
	  "\nTCP HEADER :\n"
	  "\r\t--tcp-seq or -e [SEQ] \r\t\t\t\t\t: Fixed sequence.\n"
	  "\r\t--tcp-ack or -a [ACKUSED] \r\t\t\t\t\t: Acknowledgement value.\n"
	  "\r\t--syn or -S \r\t\t\t\t\t: Flag Syn.\n"
	  "\r\t--ack or -A \r\t\t\t\t\t: Flag Ack.\n"
	  "\r\t--rst or -R \r\t\t\t\t\t: Flag Rst.\n"
	  "\r\t--fin or -F \r\t\t\t\t\t: Flag Fin.\n"
	  "\r\t--psh or -P \r\t\t\t\t\t: Flag Psh.\n"
	  "\r\t--urg or -U \r\t\t\t\t\t: Flag Urg.\n"
	  "\r\t--window or -w [SIZE] \r\t\t\t\t\t: Window size.\n"
	  "\r\t--urgptr or -u [OFFSET] \r\t\t\t\t\t: Urgent offset into data.\n"
	  "\r\t--mss or -M [SIZE] \r\t\t\t\t\t: Option MAximum Segment Size.\n"
	  "\r\t--tcp-timestamp [TIMESTAMP] \r\t\t\t\t\t: Option TCP Timestamp.\n", progname);

  exit (EXIT_FAILURE);
}

void
usage_fr (void)
{
  printf ("USAGE : %s [TARGET] [ARGV1] [ARGV2] ...\nPROGRAMME INFORMATION :\n"
	  "\r\t--help or -h \r\t\t\t\t\t: Affiche le menu aide\n"
	  "\r\t\t\t\t\t: pour afficher l'aide en US -h et en francais -hh\n"
	  "\r\t--version or -v \r\t\t\t\t\t: Affiche la version du programme\n"
	  "\nPROGRAM CONFIG :\n"
	  "\r\t--count or -c [COUNT] \r\t\t\t\t\t: Nombre de paquet a envoyer\n"
	  "\r\t--data or -l [LEN DATA] \r\t\t\t\t\t: Taille des donnes\n"
	  "\r\t--file or -f [FILE NAME] \r\t\t\t\t\t: Lire les donnes dans un fichier\n"
	  "\r\t--proto or -p [PROTOCOL] \r\t\t\t\t\t: Choix du protocol :\n"  
	  "\r\t\t\t\t\t  arp, ip, tcp, udp, icmp (igmp pas encore implent)\n"
	  "\r\t--index or -I [INDEX] \r\t\t\t\t\t: Numro de l'interface reseau a utiliser\n"
	  "\r\t--device or -i [DEVICE] \r\t\t\t\t\t: Nom de l'interface reseau a utiliser\n"
	  "\r\t--mtu or -m [MTU] \r\t\t\t\t\t: Valeur du MTU\n"
	  "\r\t--timeout or -E [TIMEOUT] \r\t\t\t\t\t: Temp de pause entre l'envoie entre chaque paquet\n"
	  "\r\t--ign-echo \r\t\t\t\t\t: Ignore les icmp echo recu pendant la dure du programme\n"
	  "\nRECV PACKET CONFIG :\n"
	  "\r\t--no-recv or -W \r\t\t\t\t\t: Ne pas lire les paquets recus\n"
	  "\r\t--verbose-recv or -V \r\t\t\t\t\t: Afficher les paquets recus le plus dtaill possible\n"
	  "\r\t--hexa-recv or -H \r\t\t\t\t\t: Afficher les paquets recus sous forme hexadecimal\n"
	  "\nCOMMON ALL PROTOCOL ETHERNET HEADER :\n"
	  "\r\t--eth-src or -y [MAC] \r\t\t\t\t\t: L'adresse MAC de l'enetete ethernet\n"
	  "\r\t--eth-dst or -Y [MAC] \r\t\t\t\t\t: L'addresse MAC de l'entete ethernet\n"
	  "\nARP HEADER :\n"
	  "\r\t--opcode or -o [OPCODE] \r\t\t\t\t\t: Opcode\n"
	  "\r\t--ar-mac-src or -n [MAC] \r\t\t\t\t\t: L'addresse MAC source\n"
	  "\r\t--ar-mac-dst or -N [MAC] \r\t\t\t\t\t: L'adresse MAC de destination\n"
	  "\r\t--ar-ip-src or -b [IP] \r\t\t\t\t\t: L'adresse IP source\n"
	  "\r\t--ar-ip-dst or -B [IP] \r\t\t\t\t\t: L'adresse IP de destination\n"
	  "\nIP HEADER :\n"
	  "\r\t--source or -s [IP] \r\t\t\t\t\t: IP source\n"
	  "\r\t--rand-src or -k \r\t\t\t\t\t: Changer l'IP source pour chaque nouveau paquet\n"
	  "\r\t--rand-ttl \r\t\t\t\t\t: Changer la TTL pour chaque nouveau paquet\n"
	  "\r\t--rand-ip-id \r\t\t\t\t\t: Changer l'ID pour chaque nouveau paquet\n"
	  "\r\t--ip-id or -D [ID] \r\t\t\t\t\t: ID fixe\n"
	  "\r\t--ttl or -t [TTL] \r\t\t\t\t\t: TTL fixe (default 169)\n"
	  "\r\t--rr \r\t\t\t\t\t: Option IP Record Route\n"
	  "\r\t--lsr [IP1,IP2,IP3,...] \r\t\t\t\t\t: Option IP Loose Source Routing\n"
	  "\r\t--ssr [IP1,IP2,IP3,...] \r\t\t\t\t\t: Option IP Strict Source Routing\n"
	  "\nCOMMON ICMP AND IGMP HEADER :\n"
	  "\r\t--type or -T [TYPE] \r\t\t\t\t\t: Type (default 8)\n"
	  "\r\t--code or -C [CODE] \r\t\t\t\t\t: Code (default 0)\n"
	  "\nIGMP HEADER :\n"
	  "\r\t--group or -G [GROUP] \r\t\t\t\t\t: pas encore implent\n"
	  "\nICMP HEADER :\n"
	  "\r\t--icmp-seq or -j [SEQ] \r\t\t\t\t\t: Sequence fixe\n"
	  "\r\t--icmp-id or -d [ID] \r\t\t\t\t\t: ID fixe\n"
	  "\r\t--router or -r [IP] \r\t\t\t\t\t: Adresse IP du touter (icmp type 5)\n"
	  "\nFOR ICMP TYPE : 3-4-5-11-12\n"
	  "\r\t--add-type or -0 [PROTOCOL] \r\t\t\t\t\t: Un protocol UDP or TCP (default TCP)\n"
	  "\r\t--add-ip-src or -1 [IP] \r\t\t\t\t\t: IP source\n"
	  "\r\t--add-ip-dst or -2 [IP] \r\t\t\t\t\t: IP destination\n"
	  "\r\t--add-p-src or -3 [PORT] \r\t\t\t\t\t: Port source\n"
	  "\r\t--add-p-dst or -4 [PORT] \r\t\t\t\t\t: Port destination\n"
	  "\r\t--add-ip-proto or -5 [PROTOCOL] \r\t\t\t\t\t: Protocole UDP ou TCP\n"
	  "\r\t--add-ip-ttl or -6 [TTL] \r\t\t\t\t\t: TTL\n"
	  "\r\t--add-ip-id or -7 [ID] \r\t\t\t\t\t: ID\n"
	  "\r\t--add-ip-fragof or -8 [OFFSET] \r\t\t\t\t\t: Fragment offset\n"
	  "\r\t--add-ip-totlen or -Q [LEN] \r\t\t\t\t\t: Taille du paquet\n"
	  "\r\t--add-tcp-seq or -9 [SEQ] \r\t\t\t\t\t: Sequence TCP\n"
	  "\r\t--add-udp-len or -z [LEN] \r\t\t\t\t\t: Taille de l'entete UDP\n"
	  "\r\t--add-udp-check or -J [CHECKSUM] \r\t\t\t\t\t: Checksum de l'entete UDP\n"
	  "\nICMP TYPE 13 & 14\n"
	  "\r\t--time-orig [TIMESTAMP] \r\t\t\t\t\t: Timestamp Origine\n"
	  "\r\t--time-send [TIMESTAMP] \r\t\t\t\t\t: Timestamp de l'envoie du paquet (type 14)\n"
	  "\r\t--time-recv [TIMESTAMP] \r\t\t\t\t\t: Timestamp de la reception du paquet (type 14)\n"
	  "\nCOMMON TCP AND UDP HEADER :\n"
	  "\r\t--psrc or -x [PORT] \r\t\t\t\t\t: Port source\n"
	  "\r\t--pdst or -X [PORT] \r\t\t\t\t\t: Port destination\n"
	  "\nTCP HEADER :\n"
	  "\r\t--tcp-seq or -e [SEQ] \r\t\t\t\t\t: Squence fixe\n"
	  "\r\t--tcp-ack or -a [AKUSED] \r\t\t\t\t\t: Ackus de reception fixe\n"
	  "\r\t--syn or -S \r\t\t\t\t\t: Flag Syn\n"
	  "\r\t--ack or -A \r\t\t\t\t\t: Flag ACK\n"
	  "\r\t--rst or -R \r\t\t\t\t\t: Flag RST\n"
	  "\r\t--fin or -F \r\t\t\t\t\t: Flag FIN\n"
	  "\r\t--psh or -P \r\t\t\t\t\t: Flag PSH\n"
	  "\r\t--urg or -U \r\t\t\t\t\t: Flag URG\n"
	  "\r\t--window or -w [SIZE] \r\t\t\t\t\t: Taille de la fenetre\n"
	  "\r\t--urgptr or -u [OFFSET] \r\t\t\t\t\t: Offset des donnes urgente\n"
	  "\r\t--mss or -M [SIZE] \r\t\t\t\t\t: Option MAximum Segment Size\n"
	  "\r\t--tcp-timestamp [TIMESTAMP] \r\t\t\t\t\t: Option TCP Timestamp\n", progname);

  exit (EXIT_SUCCESS);
}
